<?php
/* 
### Автор: NESCOKE (в прошлом SAYDEV)

Продажа данного ядра запрещена и при появлении ее на торговых точках:
Будет означать блокировку товара или вашего аккаунта на этой площадке, 
а так же претензия на WMID. 

КОНТАКТЫ: 
Веб сайт: NESCOKE.RU
Электронная почта: a.nescoke@mail.ru
Вконтакте: vk.com/nescoke
Инстаграм: instagram.com/a.nescoke
Ватсап: +79621626539
*/

$start = microtime(true);

// Определяем переменные с информацией для подключения к базе данных
$host = 'localhost'; // Наименование хоста
$db   = 'game'; // Наименование базы данных
$user = 'root'; // Имя пользователя для доступа
$pass = ''; // Пароль для доступа к базе
$charset = 'utf8'; // Дефолтная кодировка

// Включаем показ ошибок sql
mysqli_report(MYSQLI_REPORT_ERROR | MYSQLI_REPORT_STRICT);

// Подключаемся к базе (это самый лучший способ подключения)
try {
    $mysqli = mysqli_connect($host, $user, $pass, $db);
    mysqli_set_charset($mysqli, $charset);
    
// Позволяет работать в режиме отладки
} catch (\mysqli_sql_exception $e) {
     throw new \mysqli_sql_exception($e->getMessage(), $e->getCode());
}
// Больше нам эти переменные не понадобятся
unset($host, $db, $user, $pass, $charset);

session_start();
ob_start();

// Обертка для удобного использования подготовленных выражений
function saycode($mysqli, $sql, $bind, $type = "") {
    $type = $type ?: str_repeat("s", count($bind));
    $stmt = $mysqli->prepare($sql);
    $stmt->bind_param($type, ...$bind);
    $stmt->execute();
    return $stmt;
}

// Проверяем, есть ли ключи доступа
if(isset($_COOKIE['AccessToken']) AND isset($_COOKIE['SetKey']) AND isset($_COOKIE['uKey'])) {
	
	// Ключи есть, отлично, ищем в базе совпадения
$sql = "SELECT * FROM logautch WHERE AccessToken=? AND SetKey=? AND ip=? LIMIT 1";
$result = saycode($mysqli, $sql, [$_COOKIE['AccessToken'],$_COOKIE['SetKey'], $_COOKIE['uKey'] ], 'ssi')->get_result()->fetch_assoc();

// Ищем такого пользователя
$sql = "SELECT * FROM profile WHERE id=?";
$profile = saycode($mysqli, $sql, [$result['profile']], 'i')->get_result()->fetch_assoc();

// Проверим, что переменные не пусты
if(isset($profile['id']) AND isset($result)){
	
	// Проверяем, что профиль был именно тот который нужен и начинаем проверку ключей
	if($result['profile'] !== $profile['id']){
		
		if($result['AccessToken'] !== $_COOKIE['AccessToken'] OR 
	                                            $result['SetKey'] !== $_COOKIE['SetKey'] OR 
	                                            $result['ip'] !== $_COOKIE['uKey']){
	                                            	
	                                            	
	
	// Удаляем куки и отправляем лесом
        setcookie('AccessToken', '', time()+86400*365, '/');
        setcookie('SetKey', '', time()+86400*365, '/');
        setcookie('uKey', '', time()+86400*365, '/');
        header('Location: /index.php');
        exit;
    
}


// Удаляем куки и отправляем лесом
        setcookie('AccessToken', '', time()+86400*365, '/');
        setcookie('SetKey', '', time()+86400*365, '/');
        setcookie('uKey', '', time()+86400*365, '/');
        header('Location: /index.php');
        exit;
        
}else{
	// Здесь проверим IP и USER AGENT и если они отличаются, будем отправлять сообщение, а так же здесь же будет обновлять онлайн
	
	}
}else{
	
	 // Если такая кука есть, а пользователь не найдет, то и делать ей нечего в браузере пользователя, а тем более и у нас
        setcookie('AccessToken', '', time()+86400*365, '/');
        setcookie('SetKey', '', time()+86400*365, '/');
        setcookie('uKey', '', time()+86400*365, '/');
        header('Location: /index.php');
        exit;
}
}

// Доступно только не авторизованным пользователям
function noauth(){
	if($profile['id']){
		header('Location: /echosite.php');
		exit;
	}
}

// Доступно только авторизованным пользователям
function auth(){
	if(!$profile['id']){
		header('Location: /echosite.php');
		exit;
	}
}

?>